exit_polling/poller_phx/lib/poller_phx_web/router.ex
defmodule PollerPhxWeb.Router do
  alias PollerPhxWeb.ChoiceController
  use PollerPhxWeb, :router

  pipeline :browser do
    plug :accepts, ["html"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers
    plug PollerPhxWeb.Plugs.Auth
  end

  pipeline :api do
    plug :accepts, ["json"]
    plug :fetch_session
    plug PollerPhxWeb.Plugs.Auth
  end

  scope "/", PollerPhxWeb do
    pipe_through :browser

    get "/", PageController, :index
  end

  scope "/auth", PollerPhxWeb do
    pipe_through :browser

    get "/login", AuthController, :new
    post "/login", AuthController, :create
    delete "/logout", AuthController, :delete
  end

  scope "/districts", PollerPhxWeb do
    pipe_through [:browser, :valid_user, :admin_user]

    # get "/", DistrictController, :index
    # get "/new", DistrictController, :new
    # post "/", DistrictController, :create
    # get "/:id/edit", DistrictController, :edit
    # put "/:id", DistrictController, :update
    # delete "/:id", DistrictController, :delete

    # The below replaces the above
    resources "/", DistrictController, except: [:show]

    # Questions
    resources "/:district_id/questions", QuestionController, except: [:show]

    # Choices
    resources "/:district_id/questions/:question_id/choices", ChoiceController, except: [:show]
  end


  # Other scopes may use custom stacks.
  scope "/api", PollerPhxWeb.Api do
    pipe_through :api

    get "/districts", DistrictController, :index
    get "/districts/:district_id", DistrictController, :show
    get "/districts/:district_id/questions", QuestionController, :index
    get "/questions/:question_id/choices", ChoiceController, :index
  end

  scope "/api", PollerPhxWeb.Api do
    pipe_through [:api, :valid_user]

    get "/districts/:district_id/choices/:choice_id", ChoiceController, :vote
  end

  scope "/app", PollerPhxWeb do
    pipe_through :browser

    get "/*path", AppController, :index
  end
end

exit_polling/poller_phx/lib/poller_phx_web/views/layout_view.ex
defmodule PollerPhxWeb.LayoutView do
  use PollerPhxWeb, :view
end

exit_polling/poller_phx/lib/poller_phx_web/templates/layout/_nav.html.eex
<nav>
  <div>
    <a href="/">POLLER</a>
  </div>
  <div>
    <div>
      <%= if @current_user && @current_user.admin do %>
        <%= link "Districts", to: Routes.district_path(@conn, :index) %>
      <% end %>
      <%= if @current_user do %>
        <%= link "Poll", to: Routes.app_path(@conn, :index, ["polls"]) %>
      <% end %>
      <%= link "Results", to: Routes.app_path(@conn, :index, ["results"]) %>
    </div>
    <div>
      <%= if @current_user do %>
        <%= link "Logout", to: Routes.auth_path(@conn, :delete), method: :delete %>
      <% else %>
        <%= link "Login", to: Routes.auth_path(@conn, :new) %>
      <% end %>
    </div>
  </div>
</nav>

exit_polling/poller_phx/lib/poller_phx_web/templates/layout/app.html.eex
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8"/>
    <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <title>Exit Polling</title>
    <link rel="stylesheet" href="<%= Routes.static_path(@conn, "/css/app.css") %>"/>
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.5.0/css/all.css" integrity="sha384-B4dIYHKNBt8Bc12p+WXckhzcICo0wtJAoU8YZTY5qE0Id1GSseTk6S+L3BlXeVIU" crossorigin="anonymous">
  </head>
  <body>
    <header>
    <%= render PollerPhxWeb.LayoutView, "_nav.html", assigns %>
    </header>
    <section>
      <main role="main" class="container">
        <p class="info"><%= get_flash(@conn, :info) %></p>
        <p class="error"><%= get_flash(@conn, :error) %></p>
        <%= @inner_content %>
      </main>
    </section>
    <script type="text/javascript" src="<%= Routes.static_path(@conn, "/js/app.js") %>"></script>
  </body>
</html>

exit_polling/poller_phx/lib/poller_phx_web/templates/layout/poll.html.eex
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8"/>
    <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <title>Exit Polling</title>
    <link rel="stylesheet" href="<%= Routes.static_path(@conn, "/css/app.css") %>"/>
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.5.0/css/all.css" integrity="sha384-B4dIYHKNBt8Bc12p+WXckhzcICo0wtJAoU8YZTY5qE0Id1GSseTk6S+L3BlXeVIU" crossorigin="anonymous">
  </head>
  <body>
    <header>
      <%= render PollerPhxWeb.LayoutView, "_nav.html", assigns %>
    </header>
    <section>
      <main role="main" class="container">
        <div id="app"></div>
      </main>
    </section>
    <script type="text/javascript" src="<%= Routes.static_path(@conn, "/js/poll.js") %>"></script>
  </body>
</html>